// This file created by byacc/java
// Based on Berkeley yacc version 1.9.
// Java support added by Marvin Solomon (solomon@cs.wisc.edu)
// Based on ideas from Bob Jamison (rjamison@lincom-asg.com).
// $Revision: 1.4 $
// $Date: 2003/01/20 21:38:11 $
//line 2 "classad.y"
/*--------------------------------------------------------------------
 *
 * Condor Java ClassAd library
 * Copyright (C) 1990-2003, CONDOR Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and Marvin Solomon
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General
 * Public License as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *--------------------------------------------------------------------*/
package condor.classad;
import java.io.*;
import java.util.List;
import java.util.ArrayList;
import java.util.Iterator;
/** This is the internal classad parser generated by byacc.  From outside
 * this package, it should be accessed through the wrapper class ClassAdParser.
 * @see ClassAdParser
 * @author <a href="mailto:solomon@cs.wisc.edu">Marvin Solomon</a>
 * @version 2.0
 */
class Parser {
//line 42 "Parser.java"
public static final short IDENTIFIER = 257;
public static final short INTEGER = 258;
public static final short REAL = 259;
public static final short STRING = 260;
public static final short TRUE = 261;
public static final short FALSE = 262;
public static final short ERROR = 263;
public static final short UNDEFINED = 264;
public static final short OP_LOR = 265;
public static final short OP_LAND = 266;
public static final short OP_EQ = 267;
public static final short OP_NE = 268;
public static final short OP_IS = 269;
public static final short OP_ISNT = 270;
public static final short OP_LE = 271;
public static final short OP_GE = 272;
public static final short OP_SHL = 273;
public static final short OP_SHR = 274;
public static final short OP_SHRR = 275;
public static final short UNARY = 276;
private final static short ERROR_TOKEN = 256;
private final static short lhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    2,    2,    2,    2,    2,    3,
    3,    3,    4,    4,    4,    4,    4,    4,    8,    8,
   12,   12,    9,    9,    7,    7,   13,   13,   10,   10,
    6,    6,    5,    5,    5,    5,    5,    5,    5,   11,
};
private final static short len[] = {                                         2,
    1,    5,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    1,    1,    2,    2,    2,    2,    1,
    3,    4,    1,    1,    1,    1,    1,    3,    3,    2,
    1,    2,    1,    3,    3,    2,    1,    2,    3,    5,
    4,    3,    1,    1,    1,    1,    1,    1,    1,    1,
};
private final static short defred[] = {                                      0,
   60,   55,   53,   54,   56,   57,   59,   58,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   24,    0,   30,
   34,   37,   36,   35,    0,   26,   27,   28,   29,   47,
    0,    0,    0,   46,    0,   41,    0,   43,    0,   40,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   48,    0,   45,    0,   38,
   42,    0,   39,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   21,   22,   23,    0,   31,    0,   52,    0,    0,
   49,   44,    0,   32,   51,    0,    0,    2,   50,
};
private final static short dgoto[] = {                                      38,
   17,   18,   19,   20,   21,   22,   23,   24,   39,   32,
   25,   40,   34,
};
private final static short sindex[] = {                                    910,
    0,    0,    0,    0,    0,    0,    0,    0,  910,  910,
  910,  910,  -57,  910,  870,    0,   69,    0,  -42,    0,
    0,    0,    0,    0,  -35,    0,    0,    0,    0,    0,
  -87,  -52,  -49,    0,  -24,    0, -112,    0,  -36,    0,
  910,  910,  910,  910,  910,  910,  910,  910,  910,  910,
  910,  910,  910,  910,  910,  910,  910,  910,  910,  910,
  910,  910, -227,  910,  879,    0,  -90,    0,  910,    0,
    0,  890,    0,  784,  822,  -27,  838,  793,  849,  849,
  849,  849,  -16,  -16,  -16,  -16,  102,  102,  102,  -28,
  -28,    0,    0,    0,  -26,    0,  -41,    0,   -7,  -10,
    0,    0,  910,    0,    0,  910,  910,    0,    0,
};
private final static short rindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  632,    0,   28,    0,
    0,    0,    0,    0,    1,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  754,  592,  746,  161,  726,  473,  506,
  513,  672,  391,  399,  428,  436,  110,  136,  354,   40,
   97,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
private final static short gindex[] = {                                    218,
 1134,   13,    0,    0,    0,    0,    0,    0,  -12,    0,
  -13,   16,   24,
};
private final static short table[] = {                                      33,
   33,   31,   66,   63,   65,   66,   67,   72,   61,   61,
   45,   69,   71,   59,   59,   57,   70,   58,   60,   60,
   61,   26,   27,   28,   29,   59,   57,   25,   58,    1,
   60,  103,   50,  105,   51,   30,  106,   33,   33,   19,
   30,   33,   33,   33,   33,   33,   33,   33,   64,   96,
  107,  104,   99,  100,   73,   68,    0,    0,   33,   33,
   33,    0,   33,   33,   25,   25,   44,    0,   25,   25,
   25,   25,   25,    0,   25,    0,    0,   19,    0,    0,
   19,    0,   19,   19,   19,   25,   25,   25,   36,   25,
   25,   33,    0,   33,   33,    0,   20,   19,   19,   19,
    0,   19,   19,    0,    0,   61,   45,    0,    0,   16,
   59,   57,    0,   58,    0,   60,    0,    0,    0,    0,
   25,   25,    0,    0,   33,   33,    0,    0,   50,    0,
   51,   62,   19,   19,   20,   17,    0,   20,   61,   20,
   20,   20,    0,   59,   57,    0,   58,   16,   60,    0,
   16,   25,   25,   16,   20,   20,   20,    0,   20,   20,
    6,    0,   44,   19,   19,    0,    1,   16,   16,   16,
    0,   16,   16,   17,    0,    0,   17,    0,    0,   17,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   20,
   20,    0,   43,   17,   17,   17,    0,   17,   17,    1,
    0,    6,   16,   16,    6,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   16,    6,    6,
   20,   20,    0,    6,    0,    0,    0,    0,   17,   17,
    0,   35,    0,   16,   16,    0,    0,    0,    0,   46,
   47,   48,   49,   52,   53,   54,   55,   56,    0,    0,
    0,    0,    0,    6,    6,    0,   54,   55,   56,   17,
   17,    0,    0,    0,    0,   33,   33,   33,   33,   33,
   33,   33,   33,   33,   33,   33,    0,    0,    0,   95,
    0,   97,    0,    0,    6,    6,  101,    0,    0,  102,
    0,    0,   25,   25,   25,   25,   25,   25,   25,   25,
   25,   25,   25,    0,   19,   19,   19,   19,   19,   19,
   19,   19,   19,   19,   19,    0,    0,    0,    0,    0,
  108,    0,    0,  102,  109,    0,    0,    0,    0,    0,
    0,    0,    0,   41,   42,   46,   47,   48,   49,   52,
   53,   54,   55,   56,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   18,    0,    0,    0,    0,    0,    0,
    0,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,    0,    0,   16,   16,   16,   16,   16,   16,
   16,   16,   16,   16,   16,    0,    0,    0,    0,    0,
   12,   18,    0,    0,   18,    0,    0,   18,   13,    0,
   17,   17,   17,   17,   17,   17,   17,   17,   17,   17,
   17,   18,   18,   18,    0,   18,   18,    0,    0,    0,
    0,    0,    0,    0,    0,    6,    6,   14,   12,    0,
    0,   12,    0,    0,   12,   15,   13,    0,    0,   13,
    0,    0,   13,    0,    0,    0,   18,   18,   12,   12,
   12,    0,   12,   12,    0,    0,   13,   13,   13,    0,
   13,   13,    0,    0,    0,   14,    0,    0,   14,    0,
    0,   14,    8,   15,    0,    0,   15,   18,   18,   15,
    0,    0,    0,   12,   12,   14,   14,   14,    0,   14,
   14,   13,   13,   15,   15,   15,    0,   15,   15,    0,
    0,    0,    0,    0,    0,    9,    0,    0,    0,    0,
    8,    0,   10,    8,   12,   12,    8,    0,    0,    0,
   14,   14,   13,   13,    0,    0,    0,    0,   15,   15,
    8,    8,    0,    0,    0,    8,    0,    0,    0,    0,
    0,    0,    0,    9,    0,    0,    9,    0,    0,    9,
   10,   14,   14,   10,    0,    0,   10,    0,    0,   15,
   15,    0,    0,    9,    9,    8,    8,    0,    9,    0,
   10,   10,    0,    0,    0,   10,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    4,    0,    0,    0,    0,    8,    8,    9,    9,
    0,    0,    0,    0,    0,   10,   10,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   18,   18,
   18,   18,   18,   18,   18,   18,   18,   18,   18,    9,
    9,    1,    4,    0,    0,    4,   10,   10,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    4,
    4,    0,    0,    0,    4,   12,   12,   12,   12,   12,
   12,   12,   12,   13,   13,   13,   13,   13,   13,   13,
   13,   11,    1,    0,    0,    1,    0,    0,    0,    0,
    0,    0,    0,    0,    4,    0,    0,    0,    0,    1,
    1,    0,   14,   14,   14,   14,   14,   14,   14,   14,
   15,   15,   15,   15,   15,   15,   15,   15,    0,   11,
    0,    0,   11,    0,    0,   11,    4,    0,    0,    0,
    0,    0,    0,    0,    1,    7,    0,    0,    0,   11,
   11,    0,    0,    0,   11,    0,    0,    8,    8,    8,
    8,    8,    8,    0,    0,    5,    0,    0,    0,    0,
    0,    0,    0,    3,    0,    0,    1,    0,    0,    0,
    0,    0,    0,    7,   11,   11,    7,    0,    0,    7,
    9,    9,    9,    9,    9,    9,    0,   10,   10,   10,
   10,   10,   10,    7,    7,    0,    5,    0,    7,    5,
    0,    0,    0,    0,    3,   11,   11,    3,    0,    0,
    0,    0,    0,    5,    5,    0,    0,    0,    5,    0,
    0,    3,    3,    0,    0,    0,    3,    0,    7,    7,
   61,   45,    0,    0,    0,   59,   57,    0,   58,   61,
   60,    0,    0,    0,   59,   57,    0,   58,    5,   60,
    0,    0,    0,   50,    0,   51,    3,    0,    0,    7,
    7,    0,   50,    0,   51,    0,    4,    4,   61,   45,
    0,    0,    0,   59,   57,    0,   58,    0,   60,    5,
    5,    0,    0,    0,   61,   45,    0,   44,    3,   59,
   57,   50,   58,   51,   60,   61,    0,    0,    0,    0,
   59,   57,    0,   58,    0,   60,    0,   50,    0,   51,
    0,    0,   11,    0,    0,    0,    0,   43,   50,   14,
   51,   11,    9,   37,   10,   44,    0,    0,   14,   98,
    0,    9,   11,   10,    0,    0,    0,    0,    0,   14,
    0,    0,    9,    0,   10,    0,   11,   11,   11,   11,
   11,   11,   11,    0,    0,   43,    0,    0,    0,   14,
    0,    0,    9,    0,   10,    0,    0,    0,    0,    0,
   13,    0,    0,    0,    0,    0,    0,    0,    0,   13,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   13,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    7,    7,   15,    0,   36,   12,    0,    0,    0,    0,
   13,   15,    0,    0,   12,    0,    0,    0,    0,    0,
    5,    5,   15,    0,   71,   12,    0,    0,    3,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   15,    0,    0,   12,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   42,
   46,   47,   48,   49,   52,   53,   54,   55,   56,   46,
   47,   48,   49,   52,   53,   54,   55,   56,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   46,   47,
   48,   49,   52,   53,   54,   55,   56,    0,    0,    0,
    0,    0,    0,    0,   46,   47,   48,   49,   52,   53,
   54,   55,   56,    0,    0,    0,    0,    0,    0,   52,
   53,   54,   55,   56,    0,    0,    1,    2,    3,    4,
    5,    6,    7,    8,    0,    1,    2,    3,    4,    5,
    6,    7,    8,    0,    0,    0,    1,    2,    3,    4,
    5,    6,    7,    8,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    1,    2,    3,    4,
    5,    6,    7,    8,   74,   75,   76,   77,   78,   79,
   80,   81,   82,   83,   84,   85,   86,   87,   88,   89,
   90,   91,   92,   93,   94,
};
private final static short check[] = {                                      13,
    0,   59,   93,   46,   40,   93,   59,   44,   37,   37,
   38,   61,  125,   42,   42,   43,   41,   45,   47,   47,
   37,    9,   10,   11,   12,   42,   43,    0,   45,  257,
   47,   58,   60,   41,   62,   93,   44,   37,   38,    0,
   93,   41,   42,   43,   44,   45,   46,   47,   91,   63,
   61,   93,   65,   67,   39,   32,   -1,   -1,   58,   59,
   60,   -1,   62,   63,   37,   38,   94,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   38,   -1,   -1,
   41,   -1,   43,   44,   45,   58,   59,   60,  125,   62,
   63,   91,   -1,   93,   94,   -1,    0,   58,   59,   60,
   -1,   62,   63,   -1,   -1,   37,   38,   -1,   -1,    0,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   93,   94,   -1,   -1,  124,  125,   -1,   -1,   60,   -1,
   62,   63,   93,   94,   38,    0,   -1,   41,   37,   43,
   44,   45,   -1,   42,   43,   -1,   45,   38,   47,   -1,
   41,  124,  125,   44,   58,   59,   60,   -1,   62,   63,
    0,   -1,   94,  124,  125,   -1,  257,   58,   59,   60,
   -1,   62,   63,   38,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   94,   -1,  124,   58,   59,   60,   -1,   62,   63,  257,
   -1,   41,   93,   94,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,   58,   59,
  124,  125,   -1,   63,   -1,   -1,   -1,   -1,   93,   94,
   -1,   14,   -1,  124,  125,   -1,   -1,   -1,   -1,  267,
  268,  269,  270,  271,  272,  273,  274,  275,   -1,   -1,
   -1,   -1,   -1,   93,   94,   -1,  273,  274,  275,  124,
  125,   -1,   -1,   -1,   -1,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,   -1,   -1,   -1,   62,
   -1,   64,   -1,   -1,  124,  125,   69,   -1,   -1,   72,
   -1,   -1,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,   -1,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,   -1,   -1,   -1,   -1,   -1,
  103,   -1,   -1,  106,  107,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,   -1,   -1,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,   -1,   -1,   -1,   -1,   -1,
    0,   38,   -1,   -1,   41,   -1,   -1,   44,    0,   -1,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,   58,   59,   60,   -1,   62,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  265,  266,    0,   38,   -1,
   -1,   41,   -1,   -1,   44,    0,   38,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   93,   94,   58,   59,
   60,   -1,   62,   63,   -1,   -1,   58,   59,   60,   -1,
   62,   63,   -1,   -1,   -1,   38,   -1,   -1,   41,   -1,
   -1,   44,    0,   38,   -1,   -1,   41,  124,  125,   44,
   -1,   -1,   -1,   93,   94,   58,   59,   60,   -1,   62,
   63,   93,   94,   58,   59,   60,   -1,   62,   63,   -1,
   -1,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   38,   -1,    0,   41,  124,  125,   44,   -1,   -1,   -1,
   93,   94,  124,  125,   -1,   -1,   -1,   -1,   93,   94,
   58,   59,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   38,   -1,   -1,   41,   -1,   -1,   44,
   38,  124,  125,   41,   -1,   -1,   44,   -1,   -1,  124,
  125,   -1,   -1,   58,   59,   93,   94,   -1,   63,   -1,
   58,   59,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,    0,   -1,   -1,   -1,   -1,  124,  125,   93,   94,
   -1,   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  124,
  125,    0,   41,   -1,   -1,   44,  124,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   -1,   -1,   -1,   63,  265,  266,  267,  268,  269,
  270,  271,  272,  265,  266,  267,  268,  269,  270,  271,
  272,    0,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   58,
   59,   -1,  265,  266,  267,  268,  269,  270,  271,  272,
  265,  266,  267,  268,  269,  270,  271,  272,   -1,   38,
   -1,   -1,   41,   -1,   -1,   44,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,    0,   -1,   -1,   -1,   58,
   59,   -1,   -1,   -1,   63,   -1,   -1,  265,  266,  267,
  268,  269,  270,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,    0,   -1,   -1,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   38,   93,   94,   41,   -1,   -1,   44,
  265,  266,  267,  268,  269,  270,   -1,  265,  266,  267,
  268,  269,  270,   58,   59,   -1,   41,   -1,   63,   44,
   -1,   -1,   -1,   -1,   41,  124,  125,   44,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,   63,   -1,
   -1,   58,   59,   -1,   -1,   -1,   63,   -1,   93,   94,
   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,   37,
   47,   -1,   -1,   -1,   42,   43,   -1,   45,   93,   47,
   -1,   -1,   -1,   60,   -1,   62,   93,   -1,   -1,  124,
  125,   -1,   60,   -1,   62,   -1,  265,  266,   37,   38,
   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,  124,
  125,   -1,   -1,   -1,   37,   38,   -1,   94,  125,   42,
   43,   60,   45,   62,   47,   37,   -1,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   60,   -1,   62,
   -1,   -1,   33,   -1,   -1,   -1,   -1,  124,   60,   40,
   62,   33,   43,   44,   45,   94,   -1,   -1,   40,   41,
   -1,   43,   33,   45,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,  265,  266,  267,  268,
  269,  270,   33,   -1,   -1,  124,   -1,   -1,   -1,   40,
   -1,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  265,  266,  123,   -1,  125,  126,   -1,   -1,   -1,   -1,
   91,  123,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,
  265,  266,  123,   -1,  125,  126,   -1,   -1,  265,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  123,   -1,   -1,  126,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  267,
  268,  269,  270,  271,  272,  273,  274,  275,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  267,  268,
  269,  270,  271,  272,  273,  274,  275,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  267,  268,  269,  270,  271,  272,
  273,  274,  275,   -1,   -1,   -1,   -1,   -1,   -1,  271,
  272,  273,  274,  275,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,   -1,  257,  258,  259,  260,  261,
  262,  263,  264,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,   41,   42,   43,   44,   45,   46,
   47,   48,   49,   50,   51,   52,   53,   54,   55,   56,
   57,   58,   59,   60,   61,
};
private final static short FINAL_STATE = 16;
private final static String name[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"'!'",null,null,null,"'%'","'&'",null,"'('","')'","'*'","'+'",
"','","'-'","'.'","'/'",null,null,null,null,null,null,null,null,null,null,"':'",
"';'","'<'","'='","'>'","'?'",null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,"'['",null,"']'","'^'",null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,"'{'","'|'","'}'","'~'",null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,"IDENTIFIER","INTEGER","REAL",
"STRING","TRUE","FALSE","ERROR","UNDEFINED","OP_LOR","OP_LAND","OP_EQ","OP_NE",
"OP_IS","OP_ISNT","OP_LE","OP_GE","OP_SHL","OP_SHR","OP_SHRR","UNARY",
};
private final static String rule[] = {
"$accept : Expression",
"Expression : Expr",
"Expression : Expr '?' Expression ':' Expression",
"Expr : Expr OP_LOR Expr",
"Expr : Expr OP_LAND Expr",
"Expr : Expr '|' Expr",
"Expr : Expr '^' Expr",
"Expr : Expr '&' Expr",
"Expr : Expr OP_EQ Expr",
"Expr : Expr OP_NE Expr",
"Expr : Expr OP_IS Expr",
"Expr : Expr OP_ISNT Expr",
"Expr : Expr '<' Expr",
"Expr : Expr '>' Expr",
"Expr : Expr OP_LE Expr",
"Expr : Expr OP_GE Expr",
"Expr : Expr OP_SHL Expr",
"Expr : Expr OP_SHR Expr",
"Expr : Expr OP_SHRR Expr",
"Expr : Expr '+' Expr",
"Expr : Expr '-' Expr",
"Expr : Expr '*' Expr",
"Expr : Expr '/' Expr",
"Expr : Expr '%' Expr",
"Expr : PrefixExpr",
"PrefixExpr : SuffixExpr",
"PrefixExpr : '+' PrefixExpr",
"PrefixExpr : '-' PrefixExpr",
"PrefixExpr : '!' PrefixExpr",
"PrefixExpr : '~' PrefixExpr",
"SuffixExpr : Atom",
"SuffixExpr : SuffixExpr '.' Identifier",
"SuffixExpr : SuffixExpr '[' Expression ']'",
"Atom : Identifier",
"Atom : Literal",
"Atom : List",
"Atom : Record",
"Atom : Call",
"Atom : '(' Expression ')'",
"List : '{' ListBody ListEnd",
"List : '{' ListEnd",
"ListEnd : '}'",
"ListEnd : ',' '}'",
"ListBody : Expression",
"ListBody : ListBody ',' Expression",
"Record : '[' DefinitionList RecordEnd",
"Record : '[' RecordEnd",
"RecordEnd : ']'",
"RecordEnd : ';' ']'",
"DefinitionList : Identifier '=' Expression",
"DefinitionList : DefinitionList ';' Identifier '=' Expression",
"Call : Identifier '(' ListBody ')'",
"Call : Identifier '(' ')'",
"Literal : REAL",
"Literal : STRING",
"Literal : INTEGER",
"Literal : TRUE",
"Literal : FALSE",
"Literal : UNDEFINED",
"Literal : ERROR",
"Identifier : IDENTIFIER",
};
private final static String ntname[] = {
    "Expression",
    "Expr",
    "PrefixExpr",
    "SuffixExpr",
    "Atom",
    "Literal",
    "Call",
    "Record",
    "List",
    "ListBody",
    "DefinitionList",
    "Identifier",
    "ListEnd",
    "RecordEnd"
};
/** Set to true if parsing actions should be traced. */
/*package*/ boolean tracing = false;

/** If true, accept when a prefix of the input matches. */
/*package*/ boolean acceptPrefix = false;

/** Flag used in error recovery.
 * Number of tokens that must be successfully scanned before leaving
 * error-recovery mode.
 */
private int errorLookahead;

/** Last token read by lex.  The special value -1 means there is no
 * current lookahead.
 */
private int lookahead = -1;

/** The current LALR parser state.
 *  Invariant:  state == stateStack[stackTop]
 */
private int state;

/** Fixed maximum size for the parse and value stacks (currently 500).
 * This should be more than enough unless the grammar uses right-recursive
 * rules to parse a very long list, for example
 * <pre>
 *       list : element | element ',' list ;
 * </pre>
 * on input
 * <pre>
 *       a, a, a, a, ... [500 elements in all]
 * </pre>
 * If the stack overflows, an ArrayIndexOutOfBoundsException will be thrown.
 */
private final static int STACKSIZE = 500;

/** Stack of parser states.
 *  Invariant:  state == stateStack[stackTop]
 */
private int stateStack[] = new int[STACKSIZE];

/** Stack of semantic values, parallel to stateStack */
private Object valStack[] = new Object[STACKSIZE];

/** Index in stateStack of the top (highest-numbered) element of the stack. */
private int stackTop = -1;

/** The semantic value associated with the LHS of the last production */
private Object val;

/** The semantic value associated with the last token returned by lex() */
private Object lval;

/** Print a message to System.out if tracing is true.
 * @param msg the message to print.
 */
private void trace(Object msg) {
    if (tracing) {
        System.out.println(msg);
    }
} // trace(Object)

/** Convert the current stack into a string (top of stack at right).
 * @return string version of current stack.
 */
private String showStack() {
    if (stackTop < 0) {
        return "EMPTY";
    }
    StringBuffer sb = new StringBuffer(Integer.toString(stateStack[0]));
    for (int i = 1; i <= stackTop; i++) {
        sb.append(" " + stateStack[i]);
    }
    return sb.toString();
} // showStack()

/** Translate a token number to a name.
 * @param token the code for a token.
 * @return the name of the token.
 */
private String tokenName(int token) {
    if (token == ERROR_TOKEN) {
        return "$error$";
    }
    if (token < 0 || token >= name.length) {
        return "<unknown_token>";
    }
    if (name[token] != null) {
        return name[token];
    }
    if (token > 32 && token < 127) {
        return "'" + (char)token + "'";
    }
    return "<unknown_token>";
} // tokenName(int)

/** Generate a list of all tokens that can be accepted in the current state.
 * This method is only used for printing error messages, so it doesn't have
 * to be particularly fast.
 * @return an array of token codes.
 */
private int[] validTokens(int state) {
    // Count how many there are.
    int count = 0;
    for (int token = 0; token <= name.length; token++) {
        if (token == ERROR_TOKEN) {
            continue;
        }
        if (tableLookup(sindex, state, token) >= 0
            || tableLookup(rindex, state, token) >= 0)
        {
            count++;
        }
    }

    // Gather the results.
    int[] result = new int[count];
    int i = 0;
    for (int token = 0; token <= name.length; token++) {
        if (token == ERROR_TOKEN) {
            continue;
        }
        if (tableLookup(sindex, state, token) >= 0
            || tableLookup(rindex, state, token) >= 0)
        {
            result[i++] = token;
        }
    }
    return result;
} // validTokens(int)

/** Look up a value in a compressed version of a two-dimentsional array
 * of positive integers.
 * The two-dimensional tables generated by byacc are compressed by packing
 * them in to a pair of parallel long arrays check[] and table[].
 * The virtual array V[x,y] is represented by mapping rows to contiguous
 * slices of table[] as indicated by the array start[].  Each row of
 * V[,] starts at offset start[row] in table[].  Thus the value
 * V[row,column] is stored in table[start[row] + column].  However,
 * the array V is sparse, and slots corresponding to "missing" elements of
 * V[,] may be used by other rows (or even other arrays).  The element
 * table[start[row] + column] actually contains V[row,column] if and
 * only if the corresponding element of check[] contains column:
 *   table[start[row] + column] == column.
 * A row of V that is entirely missing is represented by start[row]==0.
 * @param start a mapping from rows of V to offsets within table[] and
 * check[].
 * @param row the desired row of V.
 * @param column the resired column of V.
 * @return the value of V[row,column] if that element exists.  Otherwise,
 * return -1.
 */
private static final int tableLookup(short[] start, int row, int column) {
    int offset = start[row];
    if (offset == 0) {
        return -1;
    }
    offset += column;
    if (offset < 0) {
        return -1;
    }
    if (offset >= check.length) {
        return -1;
    }
    if (check[offset] != column) {
        return -1;
    }
    return table[offset];
} // tableLookup(short[],int,int)

/** Check whether the the unconsumed input is a syntactically valid phrase
 * according to the grammar.
 * Parsing stops at the end of the input, or the first token that cannot
 * be included in a prefix of a valid 
 * phrase according to the grammar.  If "acceptPrefix" is false and an
 * invalid token is encountered before the end of the input, an error occurs.
 * An error is also signaled if "acceptPrefix" is true but the input preceding
 * the invalid token is not a valid phrase according the the grammar.
 * <p>
 * If the input is already at end of file when this method is called, it
 * silently returns null.
 * If an error occurs, a message is printed by calling the user-supplied
 * method error(String) and the result is null.   On success, the return value
 * is the "semantic value" assigned by semantic routines to the start symbol.
 *
 * @param acceptPrefix if true, the input does not to be completely consumed.
 * @return the "semantic value" corresponding to the phrase found or null for
 * errors or end-of-file.
 */
public Object parse(boolean acceptPrefix) {
    this.acceptPrefix = acceptPrefix;
    errorLookahead = 0;
    stackTop = 0;
    state = 0;
    stateStack[stackTop] = 0;

    //outer loop: until parsing is done, either correctly, or w/error
    for (;;) {
        int prod; // set by the inner loop to the number of a production
        int nextState;

        // inner loop: figure out whether to shift or reduce
        for (;;) {
            // First check whether this is a "default-reduce" state (i.e.,
            // whether this state has only one action, which is to reduce by a
            // particular production).  If so, we don't even look at the next
            // token.
            prod = defred[state];
            if (prod != 0) {
                if (tracing) {
                    trace("Stack " + showStack()
                                + " default action is reduce by " + prod);
                }
                break;
            }

            // Get a lookahead token
            if (lookahead < 0) {
                lookahead = lex();
            }
            if (state == 0 && lookahead == 0) {
                // Nothing left to parse; just return null
                if (tracing) {
                    trace("Null input");
                }
                return null;
            }
            if (tracing) {
                trace("Stack " + showStack()
                            + " token " + lookahead
                            + " (" + tokenName(lookahead) + ")");
            }

            // Check for a shift action on this token
            nextState = tableLookup(sindex, state, lookahead);
            if (nextState >= 0) {
                state = nextState;
                stateStack[++stackTop] = state;
                valStack[stackTop] = lval;
                lookahead = -1;
                if (tracing) {
                    trace("shift to stack " + showStack());
                }
                // If we are recovering from an error, decrement the number of
                // tokens that have to be consumed before leaving recovery
                // status.
                if (errorLookahead > 0) {
                    --errorLookahead;
                }
                prod = -1;
                break;
            }

            // Check for a reduce action on this token
            prod = tableLookup(rindex, state, lookahead);
            if (prod > 0) {
                break;
            }

            // This point is only reached on an error (no shift or reduce
            // action for this state and lookahead).

            if (acceptPrefix) {
                // See if what we've seen so far would be accepted if the
                // lookhead were EOF.
                for (;;) {
                    if (tracing)
                        trace("Stack " + showStack()
                            + ": pretend lookhead EOF");
                    prod = defred[state];
                    if (prod != 0) {
                        if (tracing) {
                            trace("Default action is reduce by " + prod);
                        }
                    } else {
                        prod = tableLookup(rindex, state, 0);
                        if (tracing) {
                            trace("Reduce by " + prod + " at EOF");
                        }
                    }
                    if (prod <= 0) {
                        break;
                    }
                    reduceBy(prod);
                }
            }
            if (state == FINAL_STATE && (acceptPrefix || lookahead == 0)) {
                if (tracing) {
                    trace("Prefix matches");
                }
                // At this point, the input scanned thus far is a maximal
                // match for the start symbol of the grammar -- that is,
                // no more tokens can be consumed.  We return an indication
                // of success, and the caller can determine whether there
                // is more to consume by testing for nextToken() == 0.
                return val;
            }

            // ************ Error Recovery *********************
            if (errorLookahead==0)
            {
                // suppress this message if we are already in error-recovery
                // mode
                error("syntax error");
            }
            if (errorLookahead < 3) {
                // Pop states util we find one that can accept the "error"
                // token
                errorLookahead = 3;
                for (;;) {
                    if (stackTop<0) {
                        if (tracing) {
                            trace("Recovery deletes all left context");
                        }
                        return null;
                    }
                    nextState = tableLookup(sindex,
                                  stateStack[stackTop], ERROR_TOKEN);
                    if (nextState >= 0) {
                        if (tracing) {
                            trace("Stack " + showStack()
                                + ", error recovery shifting to state "
                                + nextState);
                        }
                        state = nextState;
                        stateStack[++stackTop] = state;
                        valStack[stackTop] = lval;
                        prod = -1;
                        break;
                    }
                    if (tracing) {
                        trace("error recovery discarding state "
                            + stateStack[stackTop]);
                    }
                    if (stackTop<0) {
                        if (tracing) {
                            trace("Recovery deletes all left context");
                        }
                        return null;
                    }
                    stackTop--;
                }
            } else { // errorLookahead == 3
                if (lookahead == 0) {
                    // Cannot recover
                    trace("Recovery hits EOF");
                    return null;
                }
                if (tracing) {
                    trace("Stack " + showStack()
                        + ", error recovery discards token " + lookahead
                        + "(" + tokenName(lookahead) + ")");
                }
                lookahead = -1;  //read another
            }
            // ************ End of Error Recovery *********************
        } // inner loop
        if (prod > 0) {
            // perform a reduction
            reduceBy(prod);
            if (state == FINAL_STATE) {
                if (lookahead < 0) {
                    lookahead = lex();
                }
            }
        }
    } // main loop
} // parse(boolean)

/** Check whether the the unconsumed input is a syntactically valid phrase
 * according to the grammar.
 * This method is equivalent to parse(true).
 * @return the "semantic value" corresponding to the phrase found or null for
 * errors or end-of-file.
 */
public Object parse() {
    return parse(true);
} // parse()

/** Turn debug tracing on or off.
 * Debugging output goes to System.out.
 * @param on if true, turn tracing on; otherwise turn it off.
 * @return the previous value.
 */
public boolean enableTracing(boolean on) {
    boolean result = tracing;
    tracing = on;
    return result;
} // enableTracing(boolean)

/** Perform the syntactic and semantic actions associated with a "reduction"
 * step.
 * @param prod the production to be used.
 */
private void reduceBy(int prod) {
    // Perform the semantic action associated with prod
    if (tracing) {
        trace("reduce by production " + prod
            + " [" + rule[prod] + "]");
    }
    int rhsLength = len[prod];

    // The default action is $$ = $1
    val = valStack[stackTop - rhsLength + 1];

    switch(prod) {
        //########## USER-SUPPLIED ACTIONS ##########
case 2:
//line 69 "classad.y"
{ val = new CondExpr(((Expr)valStack[stackTop - 4]), ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 3:
//line 72 "classad.y"
{ val = new Op(Expr.OR, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 4:
//line 73 "classad.y"
{ val = new Op(Expr.AND, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 5:
//line 74 "classad.y"
{ val = new Op(Expr.BITOR, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 6:
//line 75 "classad.y"
{ val = new Op(Expr.BITXOR, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 7:
//line 76 "classad.y"
{ val = new Op(Expr.BITAND, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 8:
//line 77 "classad.y"
{ val = new Op(Expr.EQUAL, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 9:
//line 78 "classad.y"
{ val = new Op(Expr.NOT_EQUAL, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 10:
//line 79 "classad.y"
{ val = new Op(Expr.SAME, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 11:
//line 80 "classad.y"
{ val = new Op(Expr.DIFFERENT, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 12:
//line 81 "classad.y"
{ val = new Op(Expr.LESS, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 13:
//line 82 "classad.y"
{ val = new Op(Expr.GREATER, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 14:
//line 83 "classad.y"
{ val = new Op(Expr.LESS_EQ, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 15:
//line 84 "classad.y"
{ val = new Op(Expr.GREATER_EQ, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 16:
//line 85 "classad.y"
{ val = new Op(Expr.LEFT_SHIFT, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 17:
//line 86 "classad.y"
{ val = new Op(Expr.RIGHT_SHIFT, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 18:
//line 87 "classad.y"
{ val = new Op(Expr.URIGHT_SHIFT, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 19:
//line 88 "classad.y"
{ val = new Op(Expr.PLUS, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 20:
//line 89 "classad.y"
{ val = new Op(Expr.MINUS, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 21:
//line 90 "classad.y"
{ val = new Op(Expr.TIMES, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 22:
//line 91 "classad.y"
{ val = new Op(Expr.DIV, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 23:
//line 92 "classad.y"
{ val = new Op(Expr.MOD, ((Expr)valStack[stackTop - 2]), ((Expr)valStack[stackTop - 0])); }
break;
case 26:
//line 97 "classad.y"
{ val = new Op(Expr.UPLUS, ((Expr)valStack[stackTop - 0])); }
break;
case 27:
//line 98 "classad.y"
{ val = new Op(Expr.UMINUS, ((Expr)valStack[stackTop - 0])); }
break;
case 28:
//line 99 "classad.y"
{ val = new Op(Expr.NOT, ((Expr)valStack[stackTop - 0])); }
break;
case 29:
//line 100 "classad.y"
{ val = new Op(Expr.BIT_COMPLEMENT, ((Expr)valStack[stackTop - 0])); }
break;
case 31:
//line 104 "classad.y"
{ val = new SelectExpr(((Expr)valStack[stackTop - 2]),  ((AttrName)valStack[stackTop - 0])); }
break;
case 32:
//line 105 "classad.y"
{ val = new SubscriptExpr(((Expr)valStack[stackTop - 3]), ((Expr)valStack[stackTop - 1])); }
break;
case 33:
//line 108 "classad.y"
{ val = new AttrRef(((AttrName)valStack[stackTop - 0])); }
break;
case 35:
//line 110 "classad.y"
{ val = ((ListExpr)valStack[stackTop - 0]); }
break;
case 36:
//line 111 "classad.y"
{ val = ((RecordExpr)valStack[stackTop - 0]); }
break;
case 37:
//line 112 "classad.y"
{ val = ((FuncCall)valStack[stackTop - 0]); }
break;
case 38:
//line 113 "classad.y"
{ val = ((Expr)valStack[stackTop - 1]); }
break;
case 39:
//line 116 "classad.y"
{ val = new ListExpr(((List)valStack[stackTop - 1])); }
break;
case 40:
//line 117 "classad.y"
{ val = new ListExpr(null); }
break;
case 43:
//line 124 "classad.y"
{ List l = new ArrayList(); l.add(((Expr)valStack[stackTop - 0])); val = l; }
break;
case 44:
//line 125 "classad.y"
{ List l = ((List)valStack[stackTop - 2]); l.add(((Expr)valStack[stackTop - 0])); val = l; }
break;
case 45:
//line 128 "classad.y"
{
        List l = ((List)valStack[stackTop - 1]);
        RecordExpr r = new RecordExpr(l.size());
        for (Iterator i = l.iterator(); i.hasNext(); ) {
            AttrName n = (AttrName) i.next();
            Expr e = (Expr) i.next();
            if (r.lookup(n) != null) {
                error("Duplicate definition of attribute " + n + " in Record");
            } else {
                r.insertAttribute(n, e);
            } /* if */
        } /* for */
        val = r;
    }
break;
case 46:
//line 142 "classad.y"
{ val = new RecordExpr(); }
break;
case 49:
//line 149 "classad.y"
{
        List l = new ArrayList();
        l.add(((AttrName)valStack[stackTop - 2]));
        l.add(((Expr)valStack[stackTop - 0]));
        val = l;
    }
break;
case 50:
//line 155 "classad.y"
{
        List l = ((List)valStack[stackTop - 4]);
        l.add(((AttrName)valStack[stackTop - 2]));
        l.add(((Expr)valStack[stackTop - 0]));
        val = l;
    }
break;
case 51:
//line 163 "classad.y"
{ val = new FuncCall(((AttrName)valStack[stackTop - 3]), ((List)valStack[stackTop - 1])); }
break;
case 52:
//line 164 "classad.y"
{ val = new FuncCall(((AttrName)valStack[stackTop - 2]), null); }
break;
case 53:
//line 167 "classad.y"
{ val = lval; }
break;
case 54:
//line 168 "classad.y"
{ val = lval; }
break;
case 55:
//line 169 "classad.y"
{ val = lval; }
break;
case 56:
//line 170 "classad.y"
{ val = Constant.True; }
break;
case 57:
//line 171 "classad.y"
{ val = Constant.False; }
break;
case 58:
//line 172 "classad.y"
{ val = Constant.Undef; }
break;
case 59:
//line 173 "classad.y"
{ val = Constant.Error; }
break;
case 60:
//line 176 "classad.y"
{ val = (AttrName) lval; }
break;
//line 1097 "Parser.java"
        //########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch

    if (tracing) {
        trace("Pop " + rhsLength
            + " state" + (rhsLength==1 ? "" : "s")
            + " from stack " + showStack());
    }
    stackTop -= rhsLength;
    state = stateStack[stackTop];
    int target = lhs[prod];

    // Check for special reduction <start> : <empty> in state 0
    if (state == 0 && rhsLength == 0) {
        trace("Special EOF case: shifting state " + FINAL_STATE);
        //explicitly say we're done
        state = FINAL_STATE;
    } else {
        // Consult goto tables (sort of like a shift action)
        int nextState = tableLookup(gindex, target, state);
        if (nextState >= 0) {
            // nextState = goto[LHS, state]
            if (tracing) {
                trace("Goto(" + showStack()
                    + "," + ntname[target]
                    + ") = " + nextState);
            }
            state = nextState;
        } else {
            // default goto: nextState = dgoto[LHS]
            if (tracing) {
                trace("DefaultGoto(" + ntname[target]
                    + ") = " + dgoto[target]);
            }
            state = dgoto[target];
        }
    }
    stateStack[++stackTop] = state;
    valStack[stackTop] = val;
} // reduceBy(int,int)

//line 179 "classad.y"
private static String VERSION = "$Id: Parser.java,v 1.4 2003/01/20 21:38:11 solomon Exp $";

/** Verbosity for error messages.
 * Values are:
 * 0 - no messages
 * 1 - only show message and line number
 * 2 - also echo line in question
 * 3 - also list tokens expected
 */
/*package*/ int verbosity = 3;

/** Place to send error messages.  Default is System.err. */
PrintStream errs = System.err;

public Parser(Reader rdr) {
    reader = new LineNumberReader(rdr);
} // Parser(Reader)

public Parser(InputStream str) {
    reader = new LineNumberReader(new InputStreamReader(str));
} // Parser(InputStream)

public Parser(String str) {
    reader = new LineNumberReader(new StringReader(str));
} // Parser(String)

public void reset(Reader rdr) {
    reader = new LineNumberReader(rdr);
    lookahead = -1;
} // reset(Reader)

public void reset(InputStream str) {
    reader = new LineNumberReader(new InputStreamReader(str));
    lookahead = -1;
} // reset(InputStream)

public void reset(String str) {
    reader = new LineNumberReader(new StringReader(str));
    lookahead = -1;
} // reset(String)

// Lex support

/** Stream from which lex reads input.  */
private LineNumberReader reader;

/** The current input line. */
private String lineStr;

/** A version of lineStr unpacked into an array for speedy access */
private char[] line = new char[100];

/** The number of characters in the current input line. */
private int lineLen;

/** The current position in the current input line (0 = start of line) */
private int pos;

/** The position in the current line where the current token started. */
private int tokenStart;

/** The next input character to be consumed.  */
private int curChar;

/** A table of reserved words. */
private static final String[] reserved = {
    null,
    "error",
    "false",
    "is",
    "isnt",
    "true",
    "undefined",
};

/** A table of token codes parallel to the array reserved. */
private static final int[] reservedCode = {
    0, // unused
    ERROR,
    FALSE,
    OP_IS,
    OP_ISNT,
    TRUE,
    UNDEFINED
};

/** A trie constructed from the reserved words.
 * Three parallel arrays.  The element match[j] is supposed to match the
 * next letter of the input string.  If accept[j] = n != 0, then the string
 * matched thus far is reserved word n.  If the match[j] does not match
 * the next input character and alt[j] = n != 0, try match[n] instead.
 * If the input string starts with letter c, then start matching at position
 * trieStart[c], provided trieStart[c] > 0.
 */
private static char[] match;
private static int[] accept;
private static int[] alt;
private static int[] trieStart;
static {
    String m = " error false isnt true undefined ";
        //      012345678901234567890123456789012
        //                1         2         3
    match = m.toCharArray();

    trieStart = new int['z'];
    trieStart['e'] = trieStart['E'] = 1;
    trieStart['f'] = trieStart['F'] = 7;
    trieStart['i'] = trieStart['I'] = 13;
    trieStart['t'] = trieStart['T'] = 18;
    trieStart['u'] = trieStart['U'] = 23;

    accept = new int[m.length()];
    accept[6] = 1;      // error
    accept[12] = 2;     // false
    accept[15] = 3;     // is
    accept[17] = 4;     // isnt
    accept[22] = 5;     // true
    accept[32] = 6;     // undefined

    alt = new int[m.length()];
    alt[8] = 13;
};

/** A "wired-in" version of Character.toLowerCase(c) to avoid the
 * overhead in the common case of ASCII (c < 128).
 */
private static final int[] tolower = new int[] {
       0,   1,   2,   3,   4,   5,   6,   7,
       8,   9,  10,  11,  12,  13,  14,  15,
      16,  17,  18,  19,  20,  21,  22,  23,
      24,  25,  26,  27,  28,  29,  30,  31,
      32,  33,  34,  35,  36,  37,  38,  39,
      40,  41,  42,  43,  44,  45,  46,  47,
      48,  49,  50,  51,  52,  53,  54,  55,
      56,  57,  58,  59,  60,  61,  62,  63,
      64,  97,  98,  99, 100, 101, 102, 103,
     104, 105, 106, 107, 108, 109, 110, 111,
     112, 113, 114, 115, 116, 117, 118, 119,
     120, 121, 122,  91,  92,  93,  94,  95,
      96,  97,  98,  99, 100, 101, 102, 103,
     104, 105, 106, 107, 108, 109, 110, 111,
     112, 113, 114, 115, 116, 117, 118, 119,
     120, 121, 122, 123, 124, 125, 126, 127
};

/** Print a message indicated that some particular event occurred at a given
 * point in the input.
 * @param msg the message.
 */
private void lexdebug(Object msg) {
    System.out.println("LEX: line " + reader.getLineNumber()
        + " column " + (tokenStart+1)
        + " " + msg);
} // lexdebug(Object)

/** Get the "lookahead" token: the first token not yet consumed by the
 * parser.
 * The token is not removed from the input stream.
 * @return the code for the next token.
 * @see #getNextToken()
 */
public int nextToken() {
    if (lookahead < 0) {
        lookahead = lex();
    }
    return lookahead;
} // nextToken()

/** Get the value associated with the "lookahead" token: the first token not
 * yet consumed by the parser.
 * The token is not removed from the input stream.
 * @return the value associated with the next token.
 * @see #nextToken()
 */
public Object nextValue() {
    if (lookahead < 0) {
        lookahead = lex();
    }
    return lval;
} // nextValue()

/** Get and remove the "lookahead" token: the first token not yet consumed
 * by the parser.
 * The token is removed from the input stream.
 * @return the code for the next token.
 * @see #getNextToken()
 */
public int getNextToken() {
    if (lookahead < 0) {
        lookahead = lex();
    }
    int result = lookahead;
    lookahead = -1;
    return result;
} // getNextToken()

/** Gets the next line from reader and unpacks it to the array line[].
 * @return -1 for errors, 0 for EOF, or 1 for success.
 */
private final int getLine() {
    try {
        lineStr = reader.readLine();
    } catch (IOException e) {
        e.printStackTrace();
        return -1;
    }
    if (lineStr == null) {
        return 0; // EOF
    }

    lineLen = lineStr.length();
    
    if (line.length < lineLen + 1) {
        line = new char[lineLen + 20];
    }
    lineStr.getChars(0,lineLen,line,0);
    pos = 0;
    line[lineLen] = ' ';
    return 1;
} // getLine()

/** Appends a character to the current input line.  Used to recover from
 * unterminated strings.
 * @param c the character to append.
 */
private final void appendToInput(char c) {
    lineStr += "" + c;
    lineLen = lineStr.length();
    if (line.length < lineLen + 1) {
        line = new char[lineLen + 20];
    }
    lineStr.getChars(0,lineLen,line,0);
    line[lineLen] = ' ';
} // appendToInput(char)

/** Check whether the word stored in the line[] array starting at position
 * tokenStart matches one of the reserved words.  If so, return its index
 * in the array reserved[].  Otherwise, return 0.
 * @return an index in reserved[] or 0.
 */
private final int reservedLookup() {
    // Find the starting point in the trie
    int c = line[tokenStart];
    if (c >= trieStart.length) {
        return 0;
    }
    int pos = trieStart[c];
    if (pos++ == 0) {
        return 0;
    }
    // Start matching with the second character of the input
    for (int i = tokenStart+1; ;i++) {
        c = line[i];
        if (!Character.isJavaIdentifierStart((char)c)) {
            // End of input reached.  Return the code stored in the accept[]
            // array (will be zero if we are not at an "accept" node in the
            // trie.
            return accept[pos];
        }
        if (c >= tolower.length) {
            // Reserved words in the trie are entirely made up of ASCII
            // characters (<128).  If the input contains anything else, it is
            // obviously not a reserved word.
            return 0;
        }
        // Translate to lower case
        c = tolower[c];
        while (match[pos] != c) {
            // Match failed.  See if there is an alternative match at this
            // point (sibling node in the trie).
            pos = alt[pos];
            if (pos == 0) {
                // No alternative.  No match.
                return 0;
            }
        }
        // Successfully matched one more charcter of input.
        pos++;
    }
} // reservedLookup()

/** The lexical scanner.
 * It finds the next token in the input stream and returns its token code.
 * It also sets the fields tokenStart and pos so that the text of the token
 * is in line[tokenStart ... pos-1]. (For efficiency reasons, we do not
 * return the text as a String, since that would entail allocation a new String
 * that would, in most cases, immediately become garbage.)  
 * The "semantics" associated with the current token (if any) is stored
 * in lval.
 * <p>
 * @return the token code for the next token; 0 for EOF; -1 for error.
 */
private int lex() {
    int n;
    char quote;

    lval = null;
    // Skip spaces and comments
    for (;;) {
        if (pos == lineLen || (line[pos] == '/' && line[pos+1] == '/')) {
            if ((n = getLine()) <= 0) {
                return n;
            }
            continue;
        }
        if (line[pos] == '/' && line[pos+1] == '*') {
            for (pos += 2;;pos++) {
                if (pos >= lineLen) {
                    if ((n = getLine()) <= 0) {
                        return n;
                    }
                    pos = -1;
                    continue;
                }
                if (pos < lineLen - 1
                        && line[pos] == '*'
                        && line[pos+1] == '/')
                {
                    pos += 2;
                    break;
                }
            }
            continue;
        }
        if (!Character.isWhitespace(line[pos])) {
            break;
        }
        pos++;
    }
    tokenStart = pos;

    // Identifier or reserved word
    if (Character.isJavaIdentifierStart(line[pos])) {
        do {
            pos++;
        } while (Character.isJavaIdentifierPart(line[pos]));
        int i = reservedLookup();
        if (i > 0) {
            if (tracing) {
                lexdebug("reserved word " + reservedCode[i]
                         + " (" + reserved[i] + ")");
            }
            return reservedCode[i];
        }
        lval = AttrName.fromString(
                    new String(line, tokenStart, pos - tokenStart));
        if (tracing) {
            lexdebug("ID(" + lval + ")");
        }
        return IDENTIFIER;
    }

    // Number or '.'
    if (Character.isDigit(line[pos]) || line[pos]=='.') {
        // Number or lone '.'
        int type;
        if (line[pos] == '.' && !Character.isDigit(line[pos+1])) {
            pos++;
            if (tracing) {
                lexdebug("DOT");
            }
            return '.';
        }
        // Skip any leading digits
        for (; Character.isDigit(line[pos]); pos++) {
        }
        if (line[pos] == '.') {
            // There is a decimal point.  Skip the fraction part if any.
            type = REAL;
            for (pos++; Character.isDigit(line[pos]); pos++) {
            }
        } else {
            // There was no decimal point.  For now, assume it is an
            // integer.
            type = INTEGER;
            if (line[tokenStart] == '0'
                && (line[tokenStart+1] == 'x' || line[tokenStart+1] == 'x'))
            {
                // A hex integer constant.  Note that 'e' and 'E' are hex
                // digits, so 0x123e12 is parsed as a hex integer, and
                // and 0x123e+12 is parsed as three tokens: 0x123e + 12
                int value = 0;
                int digitValue;
                for (pos = tokenStart+2;
                    (digitValue = Character.digit(line[pos],16)) >= 0;
                    pos++)
                {
                    value = (value << 4) + digitValue;
                }
                // There must be at least one digit
                if (pos == tokenStart + 2) {
                    if (tracing) {
                        lexdebug("bad number");
                    }
                    return -1;
                }
                lval = Constant.getInstance(value);
                if (tracing) {
                    lexdebug("INTEGER " + lval);
                }
                return INTEGER;
            }
        }
        // Now look for an exponent
        if (line[pos] == 'e' || line[pos] == 'E') {
            type = REAL;
            pos++;
            if (line[pos] == '+' || line[pos] == '-') {
                pos++;
            }
            if (!Character.isDigit(line[pos])) {
                if (tracing) {
                    lexdebug("bad float");
                }
                return -1;
            }
            for (pos++; Character.isDigit(line[pos]); pos++) {
            }
        }
        // Finally, compute the value
        if (type == REAL) {
            lval = Constant.getInstance(
                        Double.parseDouble(
                            new String(line, tokenStart, pos - tokenStart)));
            if (tracing) {
                lexdebug("REAL " + lval);
            }
            return REAL;
        }
        // If there was no decimal point or exponent, we have to check
        // for a leading 0, meaning octal.
        int value = 0;
        int radix = (line[tokenStart] == '0') ? 8 : 10;
        for (int i=tokenStart; i<pos; i++) {
            int digitValue = Character.digit(line[i],radix);
            if (digitValue < 0) {
                if (tracing) {
                    lexdebug("bad oct");
                }
                return -1;
            }
            value = value * radix + digitValue;
        }
        lval = Constant.getInstance(value);
        if (tracing) {
            lexdebug("INT " + lval);
        }
        return INTEGER;
    } // Number

    // Multi-character operators
    switch (line[pos++]) {
    case '!':
        // != or !
        if (line[pos] == '=') {
            pos++;
            if (tracing) {
                lexdebug("NE");
            }
            return OP_NE;
        }
        break;
    case '&':
        // && or &
        if (line[pos] == '&') {
            pos++;
            if (tracing) {
                lexdebug("LAND");
            }
            return OP_LAND;
        }
        break;
    case '<':
        // << or <= or <
        if (line[pos] == '<') {
            pos++;
            if (tracing) {
                lexdebug("SHL");
            }
            return OP_SHL;
        }
        if (line[pos] == '=') {
            pos++;
            if (tracing) {
                lexdebug("LE");
            }
            return OP_LE;
        }
        break;
    case '=':
        // == or =
        if (line[pos] == '=') {
            pos++;
            if (tracing) {
                lexdebug("EQ");
            }
            return OP_EQ;
        }
        if (line[pos] == '?' && line[pos+1] == '=') {
            pos += 2;
            if (tracing) {
                lexdebug("IS");
            }
            return OP_IS;
        }
        if (line[pos] == '!' && line[pos+1] == '=') {
            pos += 2;
            if (tracing) {
                lexdebug("ISNT");
            }
            return OP_ISNT;
        }
        break;
    case '>':
        // >= or >> or >>> or >
        if (line[pos] == '=') {
            pos++;
            if (tracing) {
                lexdebug("GE");
            }
            return OP_GE;
        }
        if (line[pos] == '>') {
            pos++;
            if (line[pos] == '>') {
                pos++;
                if (tracing) {
                    lexdebug("SHRR");
                }
                return OP_SHRR;
            }
            if (tracing) {
                lexdebug("SHR");
            }
            return OP_SHR;
        }
        break;
    case '|':
        // || or |
        if (line[pos] == '|') {
            pos++;
            if (tracing) {
                lexdebug("LOR");
            }
            return OP_LOR;
        }
        break;
    case '"':
    case '\'':
        // String constant or quoted attribute name
        // Simply gather the characters up to an unescaped matching quote.
        // Other escape processing is done later.
        quote = line[pos - 1];
        for (;;) {
            if (pos == lineLen) {
                // Unterminated string constant.  Really should issue
                // a warning here!
                appendToInput((char) quote);
                pos++;
                break;
            }
            if (line[pos] == '\\') {
                pos +=2 ;
                continue;
            }
            if (line[pos] == quote) {
                pos++;
                break;
            }
            pos++;
        }
        if (quote == '"') {
            lval = Constant.getInstance(line, tokenStart + 1, pos - 1);
            if (tracing) {
                lexdebug("STRING(" + lval + ")");
            }
            return STRING;
        } else {
            lval = AttrName.fromText(
                                new String(line, tokenStart, pos - tokenStart));
            if (tracing) {
                lexdebug("ID(" + lval + ")");
            }
            return IDENTIFIER;
        }
    } // switch (line[pos++])
    // In all other cases, simply return the single character.  If it
    // isn't legit, the parser will catch it.
    if (tracing) {
        lexdebug("CHAR('" + line[pos-1] + "')");
    }
    return line[pos-1];
} // lex()

/** Print an error message, decorated with the current line and column number.
 * @param msg the message to print.
 */
private void error(String msg) {
    if (verbosity <= 0) {
        return;
    }
    if (verbosity == 1) {
        errs.println(msg
                + " at line " + reader.getLineNumber()
                + " column " + tokenStart);
        return;
    }
    errs.println(msg
            + " at line " + reader.getLineNumber()
            + " column " + tokenStart
            + ":");
    if (lineStr != null) {
        errs.println(lineStr);
        for (int i=0; i<tokenStart; i++) {
            errs.print(lineStr.charAt(i) == '\t' ? '\t' : ' ');
        }
        errs.println("^");
    }
    if (verbosity < 3) {
        return;
    }
    int[] valid = validTokens(state);
    if (valid.length > 0) {
        errs.print("Expecting ");
        for (int i=0; i<valid.length; i++) {
            if (i > 0) {
                errs.print(i == valid.length - 1 ? ", or " : ", ");
            }
            errs.print(tokenName(valid[i]));
        }
        errs.println(", but found " + tokenName(lookahead));
    } else {
        errs.println("Invalid token " + tokenName(lookahead));
    }
} // error(String)

/** Print a message, decorated with the current line and column number.
 * @param msg the message to print.
 */
/*package*/ void printMessage(String msg) {
    if (verbosity <= 0) {
        return;
    }
    errs.println(msg
                + " at line " + reader.getLineNumber()
                + " column " + tokenStart);
} // printMessage(String)
} // Parser
//line 1788 "Parser.java"
