// $Header: /p/condor/repository/CONDOR_SRC/src_java/condor/classad/tests/OldFormatTest.java,v 1.3 2002/07/20 21:21:36 roy Exp $

/*--------------------------------------------------------------------
 *
 * Condor Java ClassAd library
 * Copyright (C) 1990-2001, CONDOR Team, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and Marvin Solomon
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of version 2.1 of the GNU Lesser General
 * Public License as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 *
 *--------------------------------------------------------------------*/

package condor.classad.tests;

import condor.classad.*;
import condor.cedar.*;
import java.io.*;

/** Ad hoc test for {@link condor.classad.RecordExpr#transmit(DataOutput)}
 * and {@link condor.classad.ClassAdReader}.
 * @author <a href="mailto:solomon@cs.wisc.edu">Marvin Solomon</a>
 */
public class OldFormatTest {
    private static void pl(Object o) { System.err.println(o); }
    public static void main(String[] args) {
        try {
            ClassAdParser parser
                = new ClassAdParser(new FileInputStream("testads"));
            CedarOutputStream out
                = new CedarOutputStream(new FileOutputStream("tmp1"));
            RecordExpr expr;
            for (;;) {
                expr = (RecordExpr) parser.parse();
                if (expr == null)
                     break;
                pl("dumping " + expr);
                out.writeInt(1);
                try {
                    expr.transmit(out);
                } catch (InvalidObjectException e) {
                    pl(e);
                }
                int lookahead = parser.getNextToken();
                if (lookahead != ';') {
                    System.out.println("Expecting semicolon, found "
                        + lookahead);
                    break;
                }
            }
            out.writeInt(0);
            out.close();
            pl("=============");

            CedarInputStream cin
                = new CedarInputStream(new FileInputStream("tmp1"));
            ClassAdReader rdr = new ClassAdReader(cin);
            for (;;) {
                int c = rdr.read();
                if (c == -1)
                    break;
                System.err.print((char) c);
            }
            System.err.println();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
